<template>
  <div>
    <v-row class="fill-height">
      <v-col>
        <v-sheet height="64">
          <v-toolbar flat>
            <v-btn
              outlined
              class="mr-4"
              color="grey darken-2"
              @click="setToday"
            >
              Hoy
            </v-btn>
            <v-btn fab text small color="grey darken-2" @click="prev">
              <v-icon small>
                mdi-chevron-left
              </v-icon>
            </v-btn>
            <v-btn fab text small color="grey darken-2" @click="next">
              <v-icon small>
                mdi-chevron-right
              </v-icon>
            </v-btn>
            <v-toolbar-title v-if="$refs.calendar" class="text-capitalize">
              {{ $refs.calendar.title }}
            </v-toolbar-title>
            <v-spacer />
            <v-menu bottom right>
              <template #activator="{ on, attrs }">
                <v-btn outlined color="grey darken-2" v-bind="attrs" v-on="on">
                  <span>{{ typeToLabel[type] }}</span>
                  <v-icon right>
                    mdi-menu-down
                  </v-icon>
                </v-btn>
              </template>
              <v-list>
                <!-- <v-list-item @click="type = 'day'">
                  <v-list-item-title>Día</v-list-item-title>
                </v-list-item> -->
                <v-list-item @click="type = 'week'">
                  <v-list-item-title>Semana</v-list-item-title>
                </v-list-item>
                <!-- <v-list-item @click="type = 'month'">
                  <v-list-item-title>Mes</v-list-item-title>
                </v-list-item>
                <v-list-item @click="type = '4day'">
                  <v-list-item-title>4 días</v-list-item-title>
                </v-list-item> -->
              </v-list>
            </v-menu>
          </v-toolbar>
        </v-sheet>
        <v-sheet :height="type === 'month' ? 600 : ''">
          <v-calendar
            ref="calendar"
            v-model="value"
            locale="es"
            :type="type"
            :interval-format="intervalFormat"
            interval-count="12"
            first-time="08:00"
            :events="events"
            :event-color="getEventColor"
            :event-ripple="false"
            event-overlap-mode="column"
            @change="getEvents"
            @click:event="selectAvailibility"
          />
        </v-sheet>
      </v-col>
    </v-row>
    <v-row>
      <v-col>
        <v-icon :color="colors[0]">
          mdi-square
        </v-icon>
        <span class="mr-5"> Disponible </span>
        <v-icon :color="colors[1]">
          mdi-square
        </v-icon>
        <span> Reservado </span>
        <v-icon :color="colors[2]">
          mdi-square
        </v-icon>
        <span> Seleccionado </span>
      </v-col>
    </v-row>
  </div>
</template>

<script>
import { mapActions, mapState } from 'vuex';

export default {
  props: {
    uuid: {
      type: String,
      default: '',
    },
    selectAvailability: {
      type: Function,
      default: () => { return 1; },
    },
  },
  data: () => ({
    type: 'week',
    typeToLabel: {
      month: 'Mes',
      week: 'Semana',
      day: 'Día',
      '4day': '4 días',
    },
    value: '',
    events: [],
    colors: ['#4de08a', '#1a73e8', 'black'],
    enableCalendar: false,
    disabledCancel: true,
  }),
  computed: {
    ...mapState({
      availability: state => state.calendar.availability,
      loading: state => state.calendar.availability,
    }),
  },
  watch: {
    availability(val) {
      this.getEvents();
    },
  },
  mounted() {
    this.initialize(this.uuid);
    console.log(this.uuid);
  },
  methods: {
    ...mapActions({
      registerAvailability: 'calendar/registerAvailability',
      getAvailability: 'calendar/getAvailability',
    }),
    getWeek() {
      let curr = new Date();
      if (this.value) {
        curr = new Date(this.value);
        curr.setHours(curr.getHours() + 5);
      }
      let dateBegin = new Date(curr.setDate(curr.getDate() - curr.getDay()));
      let dateEnd = new Date(curr.setDate(curr.getDate() - curr.getDay() + 6));
      dateBegin = this.formatDateN(dateBegin);
      dateEnd = this.formatDateN(dateEnd);
      return { dateBegin, dateEnd };
    },
    async initialize() {
      const specialistUuid = this.uuid;
      const { dateBegin, dateEnd } = this.getWeek();
      await this.getAvailability({ specialistUuid, dateBegin, dateEnd });
    },
    getEventColor(event) {
      const eventColor = this.colors[event.state];
      const rgb = parseInt(eventColor.substring(1), 16);
      const r = (rgb >> 16) & 0xFF;
      const g = (rgb >> 8) & 0xFF;
      const b = (rgb >> 0) & 0xFF;

      return event === this.dragEvent
        ? `rgba(${r}, ${g}, ${b}, 0.7)`
        : event === this.createEvent
          ? `rgba(${r}, ${g}, ${b}, 0.7)`
          : eventColor;
    },
    getEvents() {
      this.enableCalendar = false;
      this.disabledCancel = true;
      const eventsArray = this.availability;
      const formatEvents = eventsArray.map((event) => {
        return {
          id: event.id,
          name: event.state === 0 ? 'Disponible' : 'Ocupado',
          start: new Date(event.startTime),
          end: new Date(event.endTime),
          state: event.state,
          timed: true,
          sessionId: event.sessionId || '1',
        };
      });
      this.events = formatEvents;
    },
    setToday() {
      this.value = '';
      this.initialize(this.uuid);
    },
    intervalFormat(locale, getOptions) {
      return locale.time;
    },
    prev() {
      this.$refs.calendar.prev();
      this.initialize(this.uuid);
    },
    next() {
      this.$refs.calendar.next();
      this.initialize(this.uuid);
    },
    selectAvailibility({ event }) {
      if (event.state !== 1 && event.start >= new Date()) {
        console.log('FUNCION', event);
        for (const e of this.events) {
          if (e.state === 2) {
            console.log('Nombre: ', e.name, e.state);
            e.state = 0;
          }
          if (e.id === event.id) { e.state = 2; }
        }
        this.selectAvailability(event.id, event.start, event.end);
      }
    },
    formatDateN(d) {
      const ye = new Intl.DateTimeFormat('en', { year: 'numeric' }).format(d);
      const mo = new Intl.DateTimeFormat('en', { month: '2-digit' }).format(d);
      const da = new Intl.DateTimeFormat('en', { day: '2-digit' }).format(d);
      return `${ye}-${mo}-${da}`;
    },
  },
};
</script>

<style scoped lang="scss">
.v-event-draggable {
  padding: 4px;
  text-align: right;
}

.v-event-timed {
  user-select: none;
  -webkit-user-select: none;
}

.v-event-drag-bottom {
  position: absolute;
  left: 0;
  right: 0;
  bottom: 4px;
  height: 4px;
  cursor: ns-resize;

  &::after {
    display: none;
    position: absolute;
    left: 50%;
    height: 4px;
    border-top: 1px solid white;
    border-bottom: 1px solid white;
    width: 16px;
    margin-left: -8px;
    opacity: 0.8;
    content: "";
  }

  &:hover::after {
    display: block;
  }
}
</style>
